#
#
#               OpenPegasus (Red Hat release) RPM .spec file
#
#  tog-pegasus.spec
#
#   Copyright (c) 2000 - 2006, 
#     The Open Group; Hewlett-Packard Development Company, L.P.;
#     IBM Corp.;  BMC Software; Tivoli Systems.
#     Licensed under the "Open Group Pegasus Open Source" license 
#     shipped with this software.
#
#  Upstream tog-pegasus.spec file modified for Red Hat build -
#  April 2006, Jason Vas Dias <jvdias@redhat.com>, Red Hat Inc.
#

%{?!LINUX_VERSION: 		%define LINUX_VERSION  %{?dist}}
#
%{?!PEGASUS_BUILD_TEST_RPM:   	%define PEGASUS_BUILD_TEST_RPM        0}
# do "rpmbuild --define 'PEGASUS_BUILD_TEST_RPM 1'" to build test RPM.
#
%{?!NOCLEAN:     		%define NOCLEAN 0}
# ^- 1: don't do %clean
%{?!NODEBUGINFO: 		%define NODEBUGINFO 0}
# ^- 1: don't generate debuginfo or strip binaries
%if %{NODEBUGINFO}
%define debug_package   %{nil}
%endif
%define srcname    	pegasus
%define pegasus_gid	65
%define pegasus_uid	66

Version:		2.7.1
Release: 		2.0.1%{?dist}
Epoch:   		2
#
Summary:   		OpenPegasus WBEM Services for Linux
Name:      		tog-pegasus
Group:     		Systems Management/Base
URL:       		http://www.openpegasus.org
#
License:   		Open Group Pegasus Open Source
#
BuildRoot: 		%{_tmppath}/%{name}-%{version}-%{release}-%{_target_cpu}-%(%{__id} -u -n)
#
Source:    		http://www.openpegasus.org/uploads/40/10123/pegasus-%{version}.tar.gz
Source1:		RedHat.OpenPegasus.Makefile
Source2:        	README.RedHat.Security
Source3:		genOpenPegasusSSLCerts
Source4:		access.conf
#
Patch1:			pegasus-2.7.0-no-rpath.patch
# patch 2 now upstream
Patch3:			pegasus-2.7.0-PIE.patch
#
# patches 4, 10, 12-14, 17-37 now upstream
#
Patch5:			pegasus-2.7.0-redhat-config.patch
Patch6:			pegasus-2.6.0-cmpi-provider-lib.patch
Patch7:			pegasus-2.7.1-local-or-remote-auth.patch
Patch8:			pegasus-2.7.1-pam-wbem.patch
# patch 9 now upstream
Patch11:		pegasus-2.5.1-fix_tests.patch
Patch15:		pegasus-2.6.0-PATH_MAX.patch
Patch39:		pegasus-2.6.0-multilib.patch
Patch40:		pegasus-2.6.0-cimuser.patch
Patch43:		pegasus-2.7.0-no_privilege_separation.patch
Patch44:		pegasus-2.7.0-no_snmp_tests.patch
Patch45:                pegasus-2.7.1-bz454589.patch
Patch46:                pegasus-2.7.1-bz454590.patch
Patch47:                pegasus-2.7.1-bz454591.patch
Patch49:		pegasus-2.7.1-initscript.patch
Patch100:               pegasus-enterprise.patch
#
Conflicts: 		openwbem
Provides: 		tog-pegasus-cimserver
#
BuildRequires:      	bash, sed, grep, coreutils, procps, gcc, gcc-c++
BuildRequires:      	libstdc++, make, pam-devel
BuildRequires:      	openssl-devel >= 0.9.8b, e2fsprogs, net-snmp-devel
Requires:           	bash, sed, grep, coreutils, procps, openssl >= 0.9.8b, pam
Requires:          	redhat-lsb, chkconfig, SysVinit
Requires:           	e2fsprogs, bind-utils, net-tools, net-snmp
Requires(post):     	bash, sed, grep, coreutils, procps, openssl >= 0.9.8b, pam
Requires(post):    	redhat-lsb, chkconfig, SysVinit
Requires(post):     	e2fsprogs, bind-utils, net-tools
Requires(pre):      	bash, sed, grep, coreutils, procps, openssl >= 0.9.8b, pam
Requires(pre):     	redhat-lsb, chkconfig, SysVinit
Requires(pre):      	e2fsprogs, bind-utils, net-tools
Requires(postun):   	bash, sed, grep, coreutils, procps, openssl >= 0.9.8b, pam
Requires(postun):  	redhat-lsb, chkconfig, SysVinit
Requires(postun):   	e2fsprogs, bind-utils, net-tools

%description
OpenPegasus WBEM Services for Linux enables management solutions that deliver
increased control of enterprise resources. WBEM is a platform and resource
independent DMTF standard that defines a common information model and
communication protocol for monitoring and controlling resources from diverse
sources.

%package devel
Summary: 		The OpenPegasus Software Development Kit
Group: 			Systems Management/Base
PreReq: 		tog-pegasus >= 2:%{version}-%{release}
Obsoletes: 		tog-pegasus-sdk
Requires:		make, gcc, gcc-c++
Requires(preun): 	make

%description devel
The OpenPegasus WBEM Services for Linux SDK is the developer's kit for the
OpenPegasus WBEM Services for Linux release. It provides Linux C++ developers
with the WBEM files required to build WBEM Clients and Providers. It also
supports C provider developers via the CMPI interface.

%if %{PEGASUS_BUILD_TEST_RPM}
%package test
Summary: 		The OpenPegasus Tests
Group: 			Systems Management/Base
PreReq: 		tog-pegasus >= %{version}-%{release}, make

%description test
The OpenPegasus WBEM tests for the OpenPegasus %{version} Linux rpm.
%endif

%prep
%setup -q -n %{srcname}
%patch1 -p1 -b .no-rpath
%patch3 -p1 -b .PIE
%patch5 -p1 -b .redhat-config
%patch6 -p1 -b .cmpi-provider-lib
%patch8 -p1 -b .pam-wbem
%patch11 -p1 -b .fix-tests
%patch15 -p1 -b .PATH_MAX
%patch39 -p1 -b .multilib
%patch40 -p1 -b .cimuser
%patch43 -p1 -b .no_privilege_separation
%patch44 -p1 -b .no_snmp_tests
%patch45 -p1 -b .bz454589
%patch46 -p1 -b .bz454590
%patch47 -p1 -b .bz454591
%patch7 -p1 -b .local-or-remote-auth
%patch49 -p1 -b .initscript
%patch100 -p1
find . -name 'CVS' -exec /bin/rm -rf '{}' ';' >/dev/null 2>&1 ||:;

%build
rm -rf ${RPM_BUILD_ROOT} || :;
cp -fp %SOURCE1 .;
cp -fp %SOURCE2 doc
cp -fp %SOURCE3 rpm
cp -fp %SOURCE4 rpm
export RPM_ARCH_LIB=%{_lib}
export RPM_ARCH=%{_target_cpu}
#make %{?_smp_mflags} -f RedHat.OpenPegasus.Makefile;
make -f RedHat.OpenPegasus.Makefile
%if %{PEGASUS_BUILD_TEST_RPM}
#    make %{?_smp_mflags} -f RedHat.OpenPegasus.Makefile tests;
    make -f RedHat.OpenPegasus.Makefile tests;
%endif

%install
export RPM_ARCH_LIB=%{_lib}
export RPM_ARCH=%{_target_cpu}
make -f RedHat.OpenPegasus.Makefile install prefix=$RPM_BUILD_ROOT libdir=%{_libdir} root_user=%(%{__id} -u -n) pegasus_user=%(%{__id} -u -n)
%if %{PEGASUS_BUILD_TEST_RPM}
    make -f RedHat.OpenPegasus.Makefile install_tests prefix=$RPM_BUILD_ROOT root_user=%(%{__id} -u -n) pegasus_user=%(%{__id} -u -n)    
%endif
%if %{NODEBUGINFO}
    /usr/lib/rpm/brp-compress;
    exit 0;
%endif
:;


%files
%defattr(0750, root, pegasus, 0750)
%if !%{NODEBUGINFO}
%exclude /usr/lib/debug
%endif
%defattr(0755, root, pegasus, 0750)
/usr/%{_lib}/*
%defattr(0750, root, pegasus, 0750)
/usr/sbin/*
/usr/bin/*
/usr/share/Pegasus/scripts
%defattr(0755, root, pegasus)
%config /etc/rc.d/init.d/tog-pegasus
%defattr(0640, root, pegasus, 0750)
%dir   /etc/Pegasus
%ghost %config(noreplace) /etc/Pegasus/cimserver_current.conf
%ghost %config(noreplace) /etc/Pegasus/cimserver_planned.conf
%config(noreplace) /etc/Pegasus/access.conf
%config(noreplace) /etc/pam.d/wbem
%ghost /etc/Pegasus/ssl.cnf
%ghost /etc/Pegasus/client.pem
%ghost /etc/Pegasus/server.pem
%ghost /etc/Pegasus/file.pem
%ghost /etc/Pegasus/cimserver_trust
%ghost /etc/Pegasus/indication_trust
%ghost /etc/Pegasus/crl
%dir /var/lib/Pegasus
%verify(not md5 size mtime mode group) /var/lib/Pegasus/repository
/var/lib/Pegasus/cache
%dir /var/lib/Pegasus/log
%ghost %verify(not md5 size mtime) /var/lib/Pegasus/log/install.log
%ghost %verify(not md5 size mtime) /var/lib/Pegasus/cache/trace/cimserver.trc
%dir   %attr(1750,root,pegasus) /var/run/tog-pegasus
%ghost /var/run/tog-pegasus/cimserver.pid
%ghost /var/run/tog-pegasus/cimserver_start.lock
%ghost %attr(1640,root,pegasus) /var/run/tog-pegasus/cimxml.socket
%defattr(0644, root, pegasus, 0755)
%dir /usr/share/Pegasus
/usr/share/Pegasus/mof
/usr/share/man/man8/*
/usr/share/man/man1/*
%doc doc/license.txt doc/Admin_Guide_Release.pdf doc/PegasusSSLGuidelines.htm doc/SecurityGuidelinesForDevelopers.html doc/README.RedHat.Security src/Clients/repupgrade/doc/repupgrade.html 


%files devel
%defattr(0644,root,pegasus,0755)
/usr/include/Pegasus
/usr/share/Pegasus/samples
/usr/share/Pegasus/html

%if %{PEGASUS_BUILD_TEST_RPM}
%files test
%defattr(0644,root,pegasus,0755)
%dir /usr/share/Pegasus/test
/usr/share/Pegasus/test/Makefile
/usr/share/Pegasus/test/mak
%verify(not md5 size mtime) /var/lib/Pegasus/testrepository
%defattr(0750,root,pegasus,0755)
/usr/share/Pegasus/test/bin
/usr/share/Pegasus/test/lib
%endif

%clean
%if !%{NOCLEAN}
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf $RPM_BUILD_ROOT;
[ "${RPM_BUILD_DIR}" != "/" ] && rm -rf ${RPM_BUILD_DIR}/%{srcname};
%endif

%pre
if [ $1 -eq 1 ]; then
#  first install: create the 'pegasus' user and group:
   /usr/sbin/groupadd -g %{pegasus_gid} -f -r pegasus >/dev/null 2>&1 || :;
   /usr/sbin/useradd -u %{pegasus_uid} -r -n -M -g pegasus -s /sbin/nologin -d /var/lib/Pegasus \
     	 		   -c "tog-pegasus OpenPegasus WBEM/CIM services" pegasus >/dev/null 2>&1 || :;
elif [ $1 -gt 1 ]; then
   if [ -d /var/lib/Pegasus/repository ]; then
	if [ -d /var/lib/Pegasus/prev_repository ]; then
	   mv /var/lib/Pegasus/prev_repository /var/lib/Pegasus/prev_repository_`date '+%Y-%m-%d-%s.%N'`.rpmsave;
	fi;
	mv /var/lib/Pegasus/repository /var/lib/Pegasus/prev_repository;
   fi
fi
:;

%post
ldconfig;
chkconfig --add tog-pegasus;
if [ $1 -ge 1 ]; then	
   echo `date` >>  /var/lib/Pegasus/log/install.log 2>&1 || :;
   if [ $1 -gt 1 ]; then
      if [ -d /var/lib/Pegasus/prev_repository ]; then
      #  The user's old repository was moved to /var/lib/Pegasus/prev_repository, which 
      #  now must be upgraded to the new repository in /var/lib/Pegasus/repository:
	 /usr/sbin/repupgrade 2>> /var/lib/Pegasus/log/install.log || :;
         mv /var/lib/Pegasus/prev_repository /var/lib/Pegasus/prev_repository_`date '+%Y-%m-%d-%s.%N'`.rpmsave;
      fi;
      /sbin/service tog-pegasus condrestart >/dev/null 2>&1 || :;
   fi;
fi
# setup InterOp namespace repository
if [ $1 -eq 1 ]; then
   cimmofl -uc -aEV -R/var/lib/Pegasus -n root/PG_InterOp /usr/share/Pegasus/mof/CIM29/CIM_Interop.mof
fi
:;

%preun
if [ $1 -eq 0 ]; then
   /sbin/service tog-pegasus stop >/dev/null 2>&1 || :;
   /sbin/chkconfig --del tog-pegasus >/dev/null 2>&1 || :;
fi
:;

%postun -p /sbin/ldconfig

%preun devel
if [ $1 -eq 0 ] ; then
   make --directory /usr/share/Pegasus/samples -s clean >/dev/null 2>&1 || :;
fi
:;

%changelog
* Wed Jan 21 2009 Kevin Lyons <kevin.x.lyons@oracle.com>  2:2.7.1-2.0.1
- Added pegasus-enterprise.patch to allow detection of enterprise-release

* Thu Nov 13 2008 Vitezslav Crhonek <vcrhonek@redhat.com> - 2:2.7.1-2
- Check status of both lock files and merge init script patches to one
- Fix local-or-remote-auth patch and enhance PAM security settings
  Resolves: #471371

* Wed Sep 10 2008 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.7.1-1
- Upgrade to upstream version 2.7.1
  Resolves: #453952
- Fix setElementAt() doesn't copy value of CMPI_char parameter
  Resolves: #454589
- Support CMPI MI factories that return errors
  Resolves: #454590
- Fix HTTP 401 responses lack Content-Length headers
  Resolves: #454591
- Remove debug dirs
  Resolves: #440371
- Include SNMP Indication Handler
  Resolves: #452930
- Setup the InterOp namespace correctly
  Resolves: #447673
- Fix wrong return code from init script
  Resolves: #326281
- Add cimsub to package
  Resolves: #447823

* Tue Jan 15 2008 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.7.0-1
- Upgrade to upstream version 2.7.0
  Resolves: #427498
- Fix OpenPegasus SRPM fails to build Test RPM
  Resolves: #252462
- Mark files in /var/lib/Pegasus as noverify in spec file
  Resolves: #250186

* Wed Aug 29 2007 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.6.1-2
- Fix wrong SDKEnvVar.mak
  Resolves: #251409

* Tue Aug 21 2007 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.6.1-1
- Upgrade to upstream version 2.6.1

* Thu Aug 16 2007 Miroslav Lichvar <mlichvar@redhat.com> 2:2.6.0-6
- Package cmpi C++ headers

* Wed Aug 15 2007 Miroslav Lichvar <mlichvar@redhat.com> 2:2.6.0-5
- Unhide some cmpi classes (#224275)

* Thu Jul 12 2007 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.6.0-4
- Fix wrong init script, fix init script is not world readable
  Resolves: #245335, #216905

* Fri Jun 22 2007 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.6.0-3
- Revise -multilib patch (SDKEnvVar.mak conflict)

* Tue Jun 19 2007 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.6.0-2
- Fix symlink to libcmpiCppImpl.so
  Resolves: #224275

* Mon Jun 18 2007 Vitezslav Crhonek <vcrhonek@redhat.com> 2:2.6.0-1
- Upgrade to upstream version 2.6.0
  Resolves: #227589

* Thu Jan 11 2007 Nalin Dahyabhai <nalin@redhat.com> 2:2.5.2-5
- revise multilib -devel patch so that the sample config.mak is identical
  everywhere, removing a last lingering file conflict (#222171)

* Fri Dec 8 2006 Jay Fenlason <fenlason@redhat.com> 2:2.5.2-4
- Revert the alternatives stuff, and add the -multilib patch to
  correctly close 
  bz#192754 multilib -devel conflicts for tog-pegasus
  This should also close
  bz#208949: Aborted /usr/sbin/repupgrade 2>>/var/lib/Pegasus/log/install.log

* Mon Dec  4 2006 Nalin Dahyabhai <nalin@redhat.com> - 2:2.5.2-3
- change requires: tog-pegasus to prereq: tog-pegasus so that the pegasus
  user and group will exist when we go to lay down files for tog-pegasus-devel
  (#218305)
- prereq the current version of openssl so that the right versions of
  libssl and libcrypto will be available in %%post (possible for #208949)

* Fri Aug 18 2006 Jesse Keating <jkeating@redhat.com> - 2:2.5.2-2
- rebuilt with latest binutils to pick up 64K -z commonpagesize on ppc*
  (#203001)

* Thu Jul 27 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5.2-1.fc6
- Upgrade to upstream version 2.5.2
- fix bug 198185
- fix bug 200246

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2:2.5.1-10.FC6.1
- rebuild

* Fri Jul 07 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.4.1-10
- More upstream 2.5.2_APPROVED bug fixes:
  o 4629: Pegasus freezes when it is unable to send out completely, the results of a request
  o 5073: Class Names on Reference, ReferenceNames, Assoc, AssocNames returned lower case
  o 5090: cimserver crash on a request after attempting to unload idle CMPI providers
  o 5180: OperationAggregate deleted in _enqueueResponse while member mutex held

* Fri Jun 09 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5.1-8
- Fix bug 192754: remove multilib conflicts
- More upstream 2.5.2_APPROVED bug fixes:
  o 5119: memory leak in CMPI implementation
  o 5115: fix SetConfig_EnvVar comments

* Wed May 31 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5.1-6
- Apply upstream patches for latest 2.5.2_APPROVED bugs:
  o 5046: cimprovider timeout needs to be increased
  o 5047: cimmof timeout needs to be increased
  o 5048: Invalid Pointer in CIMOperationRequestEncoder code
  o 5049: Unnecessary dependency on experimental headers
  o 5051: Improved handling of OOP indication provide module failures
  o 5053: reserveCapacity method may cause size overflow
  o 5059: XMLWriter does not escape '>' in strings
  o 5072: Potential race condition with OOP response chunks
  o 5083: CIMRequestMessage buildResponse() should be const
- Fix bug 193121: restore world read access to libraries   

* Tue May 02 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5.1-4
- fix bug 190432: %exclude /usr/lib/debug from RPM
- fix upstream OpenPegasus '2.5.2_APPROVED' bugs, applying upstream patches:
  o 4955 : Bogus Description property for OperatingSystem provider
  o 4956 : reserveCapacity method may cause size overflow on invalid input
  o 4968 : CMPI provider up-calls cause failure with out-of-process
  o 4978 : snmpDeliverTrap_netsnmp::_createSession function is not thread safe
  o 4983 : Memory leak in OOP indication generation
  o 4984 : Forked process hangs in system call
  o 4986 : Adding automated test for snmpIndication Handler
  (  http://cvs.opengroup.org/bugzilla/show_bug.cgi?id=? )
- apply upstream update to 'pegasus-2.5.1-warnings.patch' 

* Mon Apr 17 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5.1-3
- Fix repupgrade (make it use correct paths)

* Fri Apr 14 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5.1-2
- Apply patches for the two '2.5.2_APPROVED' upstream bugzillas 
  4934(4943) and 4945 :
  (http://cvs.opengroup.org/bugzilla/buglist.cgi?bug_id=4943%2C4945)
- Fix the PATH_MAX and MAXHOSTNAMELEN issues (again)

* Thu Apr 06 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5.1-1
- Upgrade to version 2.5.1 (including new upstream .spec file).

* Tue Mar  7 2006 Bill Nottingham <notting@redhat.com> - 2:2.5-9
- use an assigned uid/gid, do not loop over user ids looking for a free one

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 2:2.5-6.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jason Vas Dias <jvdias@redhat.com> - 2:2.5-6
- restore SSLv23_method SSL support now that bug 173399 is fixed
- rebuild for new gcc, glibc, glibc-kernheaders
- PAMBasicAuthenticatorUnix.cpp includes no longer include syslog.h: add
- /usr/bin/install now decides to fail if chown fails - set $INSTALL_USER, $INSTALL_GROUP

* Thu Dec 15 2005 Jason Vas Dias <jvdias@redhat.com> - 2:2.5-5
- fix bug 175434 : deal with pegasus uid/gid already existing
  on first install

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com> - 2:2.5-4.1
- rebuilt

* Wed Nov 16 2005 Jason Vas Dias <jvdias@redhat.com> - 2:2.5-4
- fix bug 173401: SSL support broken by openssl-0.9.7g -> 0.9.8a upgrade 

* Wed Nov 09 2005 Jason Vas Dias <jvdias@redhat.com> - 2:2.5-3
- Rebuild for new openssl dependencies
- Enable CMPI support for sblim-cmpi-base with ENABLE_CQL=true

* Mon Oct 31 2005 Jason Vas Dias <jvdias@redhat.com> - 2:2.5-2
- Add /usr/lib/cmpi alternate providerLibDir for sblim-cmpi-base Fedora Extras pkg
- Fix bug 171124: use numeric ids for pegasus user/group
- guidelines: do not remove pegasus user/group in %%postun.

* Fri Oct 14 2005 Tomas Mraz <tmraz@redhat.com>
- use include instead of pam_stack in pam config

* Fri Sep 30 2005 Jason Vas Dias <jvdias@redhat.com> - 2:2.5-1
- Implemented new 'make install' target.
- Re-wrote tog-pegasus.spec file from scratch.
- Ported BZ 167986 authentication code and BZ 167164 + BZ 167165 fixes from RHEL-4

* Wed Sep 28 2005 Jason Vas Dias <jvdias@redhat.com> - 2:2.5-0
- Initial build.
